import numpy as np
import pickle
#import matplotlib.pyplot as p
from astropy.table import Table, join
import xgboost as xgb
import glob
from mpi4py import MPI
import h5py
import sys

comm= MPI.COMM_WORLD
size = comm.Get_size()
rank = comm.Get_rank()


gaia_dir = "/mnt/ceph/users/gaia/dr3/hdf5/"


max_bp = 55
max_rp = 55

#bst = xgb.Booster()
#bst.load_model('real.model')

bst = xgb.XGBClassifier()
booster = xgb.Booster()
booster.load_model('real_3.model')
bst._Booster = booster



#print('ugh')
t = Table.read('full_spec_id_r1.fits')
#f = open('mean_spec_3.pkl','rb')
#mean_spec = pickle.load(f)
#f.close()

source_bits = np.array(t['source_id']) >> 43
#print('wtf')
if rank == 0:
    #print(rank)
    files = list(glob.glob(gaia_dir + 'XpContinuousMeanSpectrum/*'))
    #print(files)
    files_split = np.array_split(files,size)
else:
    files_split = None
files = comm.scatter(files_split, root=0)

#print(files)
#print('here')
y_pred_a = []
inds_a = []
ids_a = []
for i in range(len(files)):
    split1 = files[i].split('/')[-1]
    split2 = split1.split('_')[1]
    bit1 = int(split2.split('-')[0])
    bit2 = int(split2.split('-')[1][0:6])
    inds = np.where((source_bits >= bit1) & (source_bits<=bit2))[0]
    inds_a.append(inds)

    ids_a.append(t['source_id'][inds])

    #print(inds)
    #print(bit1,bit2)
    #print(source_bits[inds])
    sys.stdout.flush()
    # how to read in hdf5 to astorpy table
    all_x = np.zeros((len(inds),max_bp+max_rp))
    with  h5py.File(files[i],'r') as tspec:
        for j, idx in enumerate(inds):
	    #print(t['source_id'])
            #print(np.array(tspec['source_id']) >>43)
            #print(np.array(t['source_id'][inds][j])>>43)
            sys.stdout.flush()
            spec_ind = np.where(np.array(tspec['source_id'],dtype='int') == t['source_id'][idx])[0][0]
            #0print(spec_ind)
            sys.stdout.flush()
            all_x[j,:] =  np.concatenate([tspec['bp_coefficients'][spec_ind][:max_bp],tspec['rp_coefficients'][spec_ind][:max_rp]])/t['phot_g_mean_flux'][idx]
    #all_x = xgb.DMatrix(all_x)
    #all_x = all_x/mean_spec
    y_pred = bst.predict_proba(all_x)
    y_pred_a.append(y_pred[:,1])

y_pred = comm.gather(y_pred_a,root=0)
# inds = comm.gather(inds_a,root=0)
ids = comm.gather(ids_a, root=0)
if rank == 0:
    # inds = [x[0] for x in inds if len(x) == 1]
    ids = [np.concatenate(x) for x in ids if len(x) > 0]
    y_pred = [np.concatenate(x) for x in y_pred if len(x) > 0]

    ids = np.concatenate(ids).astype(np.int64)
    y_pred = np.concatenate(y_pred)

    spec_pred = Table({'source_id': ids, 'C_pred': y_pred})
    out_t = join(t, spec_pred, keys='source_id')

    out_t.write('all_spec_pred_r1_3.fits', overwrite=True)
